"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = __importDefault(require("react"));
var RedBox_1 = __importDefault(require("./RedBox"));
var nthNumber = function (n) {
    if (n > 3 && n < 21)
        return "th";
    switch (n % 10) {
        case 1:
            return "st";
        case 2:
            return "nd";
        case 3:
            return "rd";
        default:
            return "th";
    }
};
var RenderError = function (_a) {
    var geometryError = _a.geometryError, renderError = _a.renderError, renderErrorContext = _a.renderErrorContext, _b = _a.showStackTrace, showStackTrace = _b === void 0 ? true : _b;
    var geometryContext = react_1.default.useMemo(function () {
        if (!geometryError) {
            return;
        }
        var geometryParts = geometryError.route
            .split("/")
            .map(function (p) {
            return p
                .split("-")
                .map(function (x, i) { return (i ? x.toLowerCase() : Number.parseInt(x)); });
        });
        var component = geometryParts[geometryParts.length - 1][1];
        return "The above error occured in the ".concat(component, " node:\n\n").concat(geometryParts.reduce(function (acc, _a, idx) {
            var index = _a[0], name = _a[1];
            if (idx === 0) {
                return "";
            }
            if (idx === 1) {
                return name;
            }
            return "".concat(name, " - ").concat(index + 1).concat(nthNumber(index + 1), " child of\n").concat(acc);
        }, ""));
    }, [geometryError]);
    return ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: (renderError || geometryError) && ((0, jsx_runtime_1.jsxs)("div", __assign({ style: {
                position: "absolute",
                top: "0",
                left: "0",
                height: "100%",
                width: "100%",
            } }, { children: [renderError && ((0, jsx_runtime_1.jsx)(RedBox_1.default, { error: renderError, context: renderErrorContext === null || renderErrorContext === void 0 ? void 0 : renderErrorContext.split("\nReact will try to recreate this")[0], showStackTrace: showStackTrace })), geometryError && ((0, jsx_runtime_1.jsx)(RedBox_1.default, { error: geometryError, context: geometryContext, showStackTrace: false }))] }))) }));
};
exports.default = RenderError;
