"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = __importDefault(require("react"));
var theming_1 = require("@storybook/theming");
var tb_1 = require("react-icons/tb");
var hooks_1 = require("./hooks");
var ui_1 = require("./ui");
function useClickHandler(fn, close) {
    var _a = react_1.default.useState(false), waiting = _a[0], setWaiting = _a[1];
    var handleClick = react_1.default.useCallback(function (event) {
        event.preventDefault();
        if (!waiting) {
            setWaiting(true);
            fn().then(function () {
                setWaiting(false);
                close();
            });
        }
    }, [waiting, fn, close]);
    return [handleClick, waiting];
}
var spin = (0, theming_1.keyframes)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  0% {\n    transform: rotate(0deg);\n  }\n  100% {\n    transform: rotate(-360deg);\n  }\n"], ["\n  0% {\n    transform: rotate(0deg);\n  }\n  100% {\n    transform: rotate(-360deg);\n  }\n"])));
var Spinner = function () { return ((0, jsx_runtime_1.jsx)(tb_1.TbRefresh, { css: (0, theming_1.css)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n      animation: ", " 1s linear infinite;\n    "], ["\n      animation: ", " 1s linear infinite;\n    "])), spin) })); };
var ExportButton = function (_a) {
    var exportSTL = _a.exportSTL, exportBREP = _a.exportBREP, exportSTEP = _a.exportSTEP;
    var _b = react_1.default.useState(false), open = _b[0], setOpen = _b[1];
    var toggleOpen = react_1.default.useCallback(function () { return setOpen(function (o) { return !o; }); }, []);
    var close = react_1.default.useCallback(function () { return setOpen(false); }, []);
    var _c = useClickHandler(exportBREP, close), handleBREP = _c[0], brepWaiting = _c[1];
    var _d = useClickHandler(exportSTEP, close), handleSTEP = _d[0], stepWaiting = _d[1];
    var _e = useClickHandler(exportSTL, close), handleSTL = _e[0], stlWaiting = _e[1];
    var ref = (0, hooks_1.useClickOutside)(close);
    return ((0, jsx_runtime_1.jsxs)("div", __assign({ style: { position: "relative" }, ref: ref }, { children: [(0, jsx_runtime_1.jsx)(ui_1.Button, __assign({ title: "Export", onClick: toggleOpen }, { children: (0, jsx_runtime_1.jsx)(tb_1.TbFileDownload, {}) })), (0, jsx_runtime_1.jsxs)(ui_1.Dropdown, __assign({ open: open }, { children: [(0, jsx_runtime_1.jsxs)(ui_1.DropdownLink, __assign({ onClick: handleBREP }, { children: ["Download as BREP ", brepWaiting && (0, jsx_runtime_1.jsx)(Spinner, {})] })), (0, jsx_runtime_1.jsxs)(ui_1.DropdownLink, __assign({ onClick: handleSTEP }, { children: ["Download as STEP ", stepWaiting && (0, jsx_runtime_1.jsx)(Spinner, {})] })), (0, jsx_runtime_1.jsxs)(ui_1.DropdownLink, __assign({ onClick: handleSTL }, { children: ["Download as STL ", stlWaiting && (0, jsx_runtime_1.jsx)(Spinner, {})] }))] }))] })));
};
exports.default = ExportButton;
var templateObject_1, templateObject_2;
