"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = __importDefault(require("react"));
var ProgressBar = function (_a) {
    var progressIndicator = _a.progressIndicator, queuedTasks = _a.queuedTasks, children = _a.children;
    var _b = react_1.default.useState(0), progress = _b[0], setProgress = _b[1];
    var _c = react_1.default.useState(), message = _c[0], setMessage = _c[1];
    var _d = react_1.default.useState(false), show = _d[0], setShow = _d[1];
    react_1.default.useEffect(function () {
        if (progressIndicator && !progressIndicator.isDeleted()) {
            var timeout_1;
            var observer_1 = function (p, m) {
                timeout_1 = setTimeout(function () {
                    setShow(true);
                    setProgress(p);
                    if (m) {
                        setMessage(m);
                    }
                }, 0);
            };
            var cancel_1 = function () {
                if (timeout_1) {
                    clearTimeout(timeout_1);
                    timeout_1 = undefined;
                }
                if (!progressIndicator.isDeleted()) {
                    progressIndicator.unsubscribe(observer_1);
                }
            };
            setShow(true);
            setProgress(0);
            setMessage("Waiting for renderer...");
            progressIndicator.subscribe(observer_1);
            progressIndicator.then(function () {
                cancel_1();
                setShow(false);
            }, function (reason) {
                if (reason) {
                    setMessage("Aborting: ".concat(reason));
                    setShow(false);
                }
                else {
                    setMessage("Options changed, waiting for renderer...");
                }
            });
            return cancel_1;
        }
    }, [progressIndicator]);
    return ((0, jsx_runtime_1.jsxs)("div", __assign({ style: { width: "100%", height: "100%", position: "relative" } }, { children: [children, (0, jsx_runtime_1.jsx)("div", __assign({ style: {
                    zIndex: 1000,
                    position: "absolute",
                    bottom: 0,
                    left: 0,
                    width: "100%",
                    opacity: show ? 1 : 0,
                    transition: show ? "" : "opacity 0.5s 0.5s",
                } }, { children: (0, jsx_runtime_1.jsxs)("label", __assign({ style: { display: "block" } }, { children: [(0, jsx_runtime_1.jsxs)("div", __assign({ style: {
                                fontSize: "0.75rem",
                                padding: "0.5rem",
                                margin: "0 auto 0 0",
                                display: "block",
                                backgroundColor: "rgb(255,255,255,0.75)",
                                width: "max-content",
                                borderTopRightRadius: "4px",
                            } }, { children: [message, queuedTasks
                                    ? " (+ ".concat(queuedTasks, " task").concat(queuedTasks === 1 ? "" : "s", " in queue)")
                                    : null] })), (0, jsx_runtime_1.jsx)("progress", __assign({ css: {
                                width: "100%",
                                margin: 0,
                                backgroundColor: "rgb(255,255,255,0.75)",
                                height: 5,
                                appearance: "none",
                                border: "none",
                                padding: 0,
                                display: "block",
                                "&::-webkit-progress-bar": {
                                    backgroundColor: "transparent",
                                },
                                "&::-webkit-progress-value": {
                                    backgroundColor: "rgb(30, 167, 253)",
                                },
                                "&::-moz-progress-bar": {
                                    backgroundColor: "rgb(30, 167, 253)",
                                },
                            }, max: 1, value: progress }, { children: "".concat(Math.floor(progress * 100), "%") }))] })) }))] })));
};
exports.default = ProgressBar;
