import React from "react";
import type { GeometryError, ReactCADCore, ReactCADNode } from "@react-cad/core";
import { ViewOptions } from "./types";
interface Props {
    className?: string;
    core: ReactCADCore;
    node: ReactCADNode;
    name?: string;
    reset?: boolean;
    focus?: boolean;
    borderless?: boolean;
    highDetail?: [number, number];
    lowDetail?: [number, number];
    setDetail?: (detail: ViewOptions["detail"]) => void;
    rerender?: any;
    onError?: (error: GeometryError) => void;
}
declare const ReactCADNodeViewer: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement | undefined>>;
export default ReactCADNodeViewer;
