"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = __importDefault(require("react"));
var hooks_1 = require("./hooks");
var Toolbar_1 = __importDefault(require("./Toolbar"));
var ProgressBar_1 = __importDefault(require("./ProgressBar"));
var ReactCADNodeViewer = react_1.default.forwardRef(function (_a, forwardedRef) {
    var className = _a.className, core = _a.core, node = _a.node, name = _a.name, reset = _a.reset, focus = _a.focus, borderless = _a.borderless, _b = _a.highDetail, highDetail = _b === void 0 ? [0.001, 0.5] : _b, _c = _a.lowDetail, lowDetail = _c === void 0 ? [0.05, 0.5] : _c, setDetail = _a.setDetail, rerender = _a.rerender, onError = _a.onError;
    var wrapperRef = react_1.default.useRef(null);
    react_1.default.useImperativeHandle(forwardedRef, function () { var _a; return (_a = wrapperRef.current) !== null && _a !== void 0 ? _a : undefined; });
    var _d = react_1.default.useState({
        showAxes: false,
        showGrid: true,
        showWireframe: false,
        showShaded: true,
        projection: "ORTHOGRAPHIC",
        detail: "LOW",
        highDetail: highDetail,
        lowDetail: lowDetail,
    }), options = _d[0], setOptions = _d[1];
    var _e = (0, hooks_1.useProgressQueue)(), progressIndicator = _e[0], addTask = _e[1], queuedTasks = _e[2];
    var canvasContainerRef = react_1.default.useRef(null);
    var view = (0, hooks_1.useReactCADView)(canvasContainerRef, core, options, addTask);
    var shouldReset = react_1.default.useRef(false);
    react_1.default.useEffect(function () {
        if (rerender) {
            addTask(function () {
                if (view.current) {
                    var progress = core.renderNodeAsync(node, view.current);
                    progress.then(function () {
                        var _a;
                        if (reset || shouldReset.current) {
                            (_a = view.current) === null || _a === void 0 ? void 0 : _a.resetView();
                            shouldReset.current = false;
                        }
                    }, function (error) {
                        if (error instanceof Error) {
                            onError === null || onError === void 0 ? void 0 : onError(error);
                        }
                        shouldReset.current = Boolean(reset || shouldReset.current);
                    });
                    return progress;
                }
            });
        }
    }, [node, rerender, onError]);
    react_1.default.useEffect(function () { return setOptions(function (options) { return (__assign(__assign({}, options), { highDetail: highDetail, lowDetail: lowDetail })); }); }, __spreadArray(__spreadArray([], highDetail, true), lowDetail, true));
    react_1.default.useEffect(function () {
        setDetail === null || setDetail === void 0 ? void 0 : setDetail(options.detail);
    }, [options.detail]);
    var handleSetViewpoint = react_1.default.useCallback(function (viewpoint) {
        var _a;
        (_a = view.current) === null || _a === void 0 ? void 0 : _a.setViewpoint(core.Viewpoint[viewpoint]);
    }, []);
    var handleZoom = react_1.default.useCallback(function (amount) {
        var _a;
        (_a = view.current) === null || _a === void 0 ? void 0 : _a.zoom(amount);
    }, []);
    var handleResetView = react_1.default.useCallback(function () {
        var _a;
        (_a = view.current) === null || _a === void 0 ? void 0 : _a.resetView();
    }, []);
    var handleFit = react_1.default.useCallback(function () { var _a; return (_a = view.current) === null || _a === void 0 ? void 0 : _a.fit(); }, []);
    var exportFns = (0, hooks_1.useExport)(core, addTask, node, name);
    return ((0, jsx_runtime_1.jsx)("div", __assign({ className: className, ref: wrapperRef, style: {
            height: "100%",
            width: "100%",
            fontFamily: '"Nunito Sans", -apple-system, ".SFNSText-Regular", "San Francisco", BlinkMacSystemFont, "Segoe UI", "Helvetica Neue", Helvetica, Arial, sans-serif',
        } }, { children: (0, jsx_runtime_1.jsx)(Toolbar_1.default, __assign({ options: options, setOptions: setOptions, exportFns: exportFns, onSetViewpoint: handleSetViewpoint, onZoom: handleZoom, onFit: handleFit, onResetView: handleResetView, focus: focus, borderless: borderless }, { children: (0, jsx_runtime_1.jsx)(ProgressBar_1.default, __assign({ progressIndicator: progressIndicator, queuedTasks: queuedTasks }, { children: (0, jsx_runtime_1.jsx)("div", { style: { width: "100%", height: "100%" }, ref: canvasContainerRef, dangerouslySetInnerHTML: {
                        __html: '<canvas style="width: 100%; height: 100%" />',
                    } }) })) })) })));
});
exports.default = ReactCADNodeViewer;
