"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = __importDefault(require("react"));
var tb_1 = require("react-icons/tb");
var ui_1 = require("./ui");
var ExportButton_1 = __importDefault(require("./ExportButton"));
var ZOOM_AMOUNT = 50;
var Toolbar = function (_a) {
    var options = _a.options, setOptions = _a.setOptions, exportFns = _a.exportFns, onSetViewpoint = _a.onSetViewpoint, onZoom = _a.onZoom, onResetView = _a.onResetView, onFit = _a.onFit, focus = _a.focus, borderless = _a.borderless, children = _a.children;
    var wrapperRef = react_1.default.useRef(null);
    react_1.default.useEffect(function () {
        var _a;
        if (focus) {
            (_a = wrapperRef.current) === null || _a === void 0 ? void 0 : _a.focus();
        }
    }, [focus]);
    var toggleShaded = react_1.default.useCallback(function () {
        return setOptions(function (options) { return (__assign(__assign({}, options), { showShaded: !options.showShaded, showWireframe: options.showWireframe || options.showShaded })); });
    }, []);
    var toggleWireframe = react_1.default.useCallback(function () {
        return setOptions(function (options) { return (__assign(__assign({}, options), { showWireframe: !options.showWireframe, showShaded: options.showShaded || options.showWireframe })); });
    }, []);
    var toggleAxes = react_1.default.useCallback(function () {
        return setOptions(function (options) { return (__assign(__assign({}, options), { showAxes: !options.showAxes })); });
    }, []);
    var toggleGrid = react_1.default.useCallback(function () {
        return setOptions(function (options) { return (__assign(__assign({}, options), { showGrid: !options.showGrid })); });
    }, []);
    var setHighDetail = react_1.default.useCallback(function () { return setOptions(function (options) { return (__assign(__assign({}, options), { detail: "HIGH" })); }); }, []);
    var setLowDetail = react_1.default.useCallback(function () { return setOptions(function (options) { return (__assign(__assign({}, options), { detail: "LOW" })); }); }, []);
    var setProjection = function (projection) {
        return react_1.default.useCallback(function () { return setOptions(function (options) { return (__assign(__assign({}, options), { projection: projection })); }); }, []);
    };
    var handleZoomIn = react_1.default.useCallback(function () { return onZoom(ZOOM_AMOUNT); }, []);
    var handleZoomOut = react_1.default.useCallback(function () { return onZoom(-ZOOM_AMOUNT); }, []);
    var handleSetViewpoint = function (viewpoint) {
        return react_1.default.useCallback(function () { return onSetViewpoint(viewpoint); }, []);
    };
    var handleKeyPress = react_1.default.useCallback(function (event) {
        switch (event.key) {
            case "+":
                handleZoomIn();
                break;
            case "-":
                handleZoomOut();
                break;
            case "=":
                onFit();
                break;
            case "p":
                setOptions(function (options) { return (__assign(__assign({}, options), { projection: options.projection === "PERSPECTIVE"
                        ? "ORTHOGRAPHIC"
                        : "PERSPECTIVE" })); });
                break;
            case "x":
                toggleAxes();
                break;
            case "g":
                toggleGrid();
                break;
            case "m":
                toggleShaded();
                break;
            case "w":
                toggleWireframe();
                break;
            case "r":
                onResetView();
                break;
            case "h":
                setHighDetail();
                break;
            case "l":
                setLowDetail();
                break;
        }
        if (event.shiftKey) {
            switch (event.code) {
                case "Digit8":
                    onSetViewpoint("TOP");
                    break;
                case "Digit2":
                    onSetViewpoint("BOTTOM");
                    break;
                case "Digit4":
                    onSetViewpoint("LEFT");
                    break;
                case "Digit6":
                    onSetViewpoint("RIGHT");
                    break;
                case "Digit1":
                    onSetViewpoint("FRONT");
                    break;
                case "Digit9":
                    onSetViewpoint("BACK");
                    break;
            }
        }
    }, []);
    return ((0, jsx_runtime_1.jsxs)("div", __assign({ css: __assign(__assign({ display: "flex", alignItems: "stretch", width: "100%", height: "100%" }, (borderless ? {} : { border: "1px solid rgba(0,0,0,0.1)" })), { "&:focus": {
                outline: "rgba(30,167,253,0.5) solid 1px",
            }, "&, & *": {
                boxSizing: "border-box",
            } }), tabIndex: 0, onKeyPress: handleKeyPress, ref: wrapperRef }, { children: [(0, jsx_runtime_1.jsxs)("div", __assign({ style: {
                    display: "flex",
                    flexWrap: "wrap",
                    flexGrow: 0,
                    alignContent: "flex-start",
                    borderRight: "1px solid rgba(0,0,0,0.1)",
                    padding: "2px 1px",
                    writingMode: "vertical-lr",
                } }, { children: [(0, jsx_runtime_1.jsxs)(ui_1.Section, { children: [(0, jsx_runtime_1.jsx)(ui_1.Button, __assign({ title: "Zoom in (+)", onClick: handleZoomIn }, { children: (0, jsx_runtime_1.jsx)(tb_1.TbZoomIn, {}) })), (0, jsx_runtime_1.jsx)(ui_1.Button, __assign({ title: "Zoom out (-)", onClick: handleZoomOut }, { children: (0, jsx_runtime_1.jsx)(tb_1.TbZoomOut, {}) })), (0, jsx_runtime_1.jsx)(ui_1.Button, __assign({ title: "Zoom to fit (=)", onClick: onFit }, { children: (0, jsx_runtime_1.jsx)(tb_1.TbZoomCancel, {}) })), (0, jsx_runtime_1.jsx)(ui_1.Separator, {})] }), (0, jsx_runtime_1.jsxs)(ui_1.Section, { children: [(0, jsx_runtime_1.jsx)(ui_1.Button, __assign({ title: "Top (Shift+8)", onClick: handleSetViewpoint("TOP") }, { children: (0, jsx_runtime_1.jsx)(tb_1.TbArrowBarToDown, {}) })), (0, jsx_runtime_1.jsx)(ui_1.Button, __assign({ title: "Bottom (Shift+2)", onClick: handleSetViewpoint("BOTTOM") }, { children: (0, jsx_runtime_1.jsx)(tb_1.TbArrowBarToUp, {}) })), (0, jsx_runtime_1.jsx)(ui_1.Button, __assign({ title: "Left (Shift+4)", onClick: handleSetViewpoint("LEFT") }, { children: (0, jsx_runtime_1.jsx)(tb_1.TbArrowBarToRight, { style: { transform: "rotate(45deg)" } }) })), (0, jsx_runtime_1.jsx)(ui_1.Button, __assign({ title: "Right (Shift+6)", onClick: handleSetViewpoint("RIGHT") }, { children: (0, jsx_runtime_1.jsx)(tb_1.TbArrowBarToLeft, { style: { transform: "rotate(45deg)" } }) })), (0, jsx_runtime_1.jsx)(ui_1.Button, __assign({ title: "Front (Shift+1)", onClick: handleSetViewpoint("FRONT") }, { children: (0, jsx_runtime_1.jsx)(tb_1.TbArrowBarToUp, { style: { transform: "rotate(45deg)" } }) })), (0, jsx_runtime_1.jsx)(ui_1.Button, __assign({ title: "Back (Shift+9)", onClick: handleSetViewpoint("BACK") }, { children: (0, jsx_runtime_1.jsx)(tb_1.TbArrowBarToDown, { style: { transform: "rotate(45deg)" } }) })), (0, jsx_runtime_1.jsx)(ui_1.Button, __assign({ title: "Reset view (R)", onClick: onResetView }, { children: (0, jsx_runtime_1.jsx)(tb_1.TbArrowBackUp, {}) })), (0, jsx_runtime_1.jsx)(ui_1.Separator, {})] }), (0, jsx_runtime_1.jsxs)(ui_1.Section, { children: [(0, jsx_runtime_1.jsx)(ui_1.Button, __assign({ active: options.projection === "ORTHOGRAPHIC", title: "Orthographic (P)", onClick: setProjection("ORTHOGRAPHIC") }, { children: (0, jsx_runtime_1.jsx)(tb_1.TbSquare, {}) })), (0, jsx_runtime_1.jsx)(ui_1.Button, __assign({ active: options.projection === "PERSPECTIVE", title: "Perspective (P)", onClick: setProjection("PERSPECTIVE") }, { children: (0, jsx_runtime_1.jsx)(tb_1.TbPerspective, {}) })), (0, jsx_runtime_1.jsx)(ui_1.Separator, {})] }), (0, jsx_runtime_1.jsxs)(ui_1.Section, { children: [(0, jsx_runtime_1.jsx)(ui_1.Button, __assign({ title: "Show model (M)", onClick: toggleShaded, active: options.showShaded }, { children: (0, jsx_runtime_1.jsx)(tb_1.TbBox, {}) })), (0, jsx_runtime_1.jsx)(ui_1.Button, __assign({ title: "Show wireframe (W)", onClick: toggleWireframe, active: options.showWireframe }, { children: (0, jsx_runtime_1.jsx)(tb_1.Tb3DCubeSphere, {}) })), (0, jsx_runtime_1.jsx)(ui_1.Separator, {})] }), (0, jsx_runtime_1.jsxs)(ui_1.Section, { children: [(0, jsx_runtime_1.jsx)(ui_1.Button, __assign({ title: "Show axes (X)", onClick: toggleAxes, active: options.showAxes }, { children: (0, jsx_runtime_1.jsx)(tb_1.TbGizmo, {}) })), (0, jsx_runtime_1.jsx)(ui_1.Button, __assign({ title: "Show grid (G)", onClick: toggleGrid, active: options.showGrid }, { children: (0, jsx_runtime_1.jsx)(tb_1.TbFrame, {}) })), (0, jsx_runtime_1.jsx)(ui_1.Separator, {})] }), (0, jsx_runtime_1.jsxs)(ui_1.Section, { children: [(0, jsx_runtime_1.jsx)(ui_1.Button, __assign({ title: "High detail (H)", onClick: setHighDetail, active: options.detail === "HIGH" }, { children: (0, jsx_runtime_1.jsx)(tb_1.TbCircle, {}) })), (0, jsx_runtime_1.jsx)(ui_1.Button, __assign({ title: "Low detail (L)", onClick: setLowDetail, active: options.detail === "LOW" }, { children: (0, jsx_runtime_1.jsx)(tb_1.TbPentagon, {}) })), (0, jsx_runtime_1.jsx)(ui_1.Separator, {})] }), (0, jsx_runtime_1.jsx)(ui_1.Section, { children: (0, jsx_runtime_1.jsx)(ExportButton_1.default, __assign({}, exportFns)) })] })), (0, jsx_runtime_1.jsx)("div", __assign({ style: { flexGrow: 1 } }, { children: children }))] })));
};
exports.default = Toolbar;
