"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var subscribers = [];
var originalConsoleError = console["error"];
var consoleError = (function (message) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    subscribers.forEach(function (subscriber) { return subscriber(message); });
    originalConsoleError.apply(void 0, __spreadArray([message], args, false));
});
console["error"] = consoleError;
function useConsoleError(onError) {
    react_1.default.useEffect(function () {
        subscribers.push(onError);
        return function () {
            var index = subscribers.indexOf(onError);
            if (index >= 0) {
                subscribers.splice(index, 1);
            }
        };
    }, [onError]);
}
exports.default = useConsoleError;
