"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
function useProgressQueue() {
    var _a = react_1.default.useState(), progressIndicator = _a[0], setProgressIndicator = _a[1];
    var queue = react_1.default.useRef([]);
    var _b = react_1.default.useState(0), queueLength = _b[0], setQueueLength = _b[1];
    var then = react_1.default.useCallback(function () {
        var _a;
        var progress;
        var resolve;
        do {
            var _b = (_a = queue.current.shift()) !== null && _a !== void 0 ? _a : [], task = _b[0], r = _b[1];
            progress = task === null || task === void 0 ? void 0 : task();
            if (!progress) {
                r === null || r === void 0 ? void 0 : r();
            }
            else {
                resolve = r;
            }
        } while (queue.current.length && !progress);
        setQueueLength(queue.current.length);
        progress === null || progress === void 0 ? void 0 : progress.then(then, function () { }).then(resolve);
        if (progress) {
            setProgressIndicator(function (p) {
                p === null || p === void 0 ? void 0 : p.cancel();
                p === null || p === void 0 ? void 0 : p.delete();
                return progress;
            });
            progressRef.current = progress;
        }
        return progress;
    }, [queue]);
    var addTask = react_1.default.useCallback(function (task, cancelPrevious) {
        if (cancelPrevious === void 0) { cancelPrevious = true; }
        var queueItem = [task, function () { }];
        var promise = new Promise(function (resolve) { return (queueItem[1] = resolve); });
        if (!progressIndicator ||
            progressIndicator.isDeleted() ||
            progressIndicator.isFulfilled()) {
            queue.current.push(queueItem);
            then();
        }
        else {
            if (cancelPrevious) {
                queue.current.forEach(function (_a) {
                    var resolve = _a[1];
                    return resolve();
                });
                queue.current = [queueItem];
                progressIndicator.catch(then).catch(function () { });
                progressIndicator.cancel();
            }
            else {
                queue.current.push(queueItem);
                setQueueLength(queue.current.length);
            }
        }
        return promise;
    }, [progressIndicator, then]);
    // Cancel last task on unmount
    var progressRef = react_1.default.useRef();
    react_1.default.useEffect(function () { return function () {
        if (progressRef.current && !progressRef.current.isDeleted()) {
            progressRef.current.cancel();
            progressRef.current.delete();
        }
    }; }, []);
    return [progressIndicator, addTask, queueLength];
}
exports.default = useProgressQueue;
