"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
function useReactCADView(canvasContainerRef, core, options, addTask) {
    var canvasRef = react_1.default.useRef();
    var view = react_1.default.useRef();
    var _a = react_1.default.useState(false), loaded = _a[0], setLoaded = _a[1];
    react_1.default.useEffect(function () {
        var _a, _b;
        canvasRef.current = (_a = canvasContainerRef.current) === null || _a === void 0 ? void 0 : _a.getElementsByTagName("canvas")[0];
        if (canvasRef.current) {
            view.current = core.createView(canvasRef.current);
            var onResize = function () {
                if (view.current && canvasRef.current) {
                    canvasRef.current.width =
                        canvasRef.current.clientWidth * window.devicePixelRatio;
                    canvasRef.current.height =
                        canvasRef.current.clientHeight * window.devicePixelRatio;
                    view.current.onResize();
                }
            };
            var observer_1 = new ResizeObserver(onResize);
            observer_1.observe(canvasRef.current, {});
            var quality = options.detail === "HIGH" ? options.highDetail : options.lowDetail;
            (_b = view.current) === null || _b === void 0 ? void 0 : _b.setQuality.apply(_b, quality);
            setLoaded(true);
            return function () {
                observer_1.disconnect();
                if (canvasContainerRef.current) {
                    canvasContainerRef.current.innerHTML = "";
                    canvasRef.current = undefined;
                }
                if (view.current) {
                    view.current.delete();
                    view.current = undefined;
                }
            };
        }
    }, []);
    react_1.default.useEffect(function () {
        if (view.current) {
            view.current.showAxes(options.showAxes);
            view.current.showGrid(options.showGrid);
            view.current.showWireframe(options.showWireframe);
            view.current.showShaded(options.showShaded);
            view.current.setProjection(core.Projection[options.projection]);
        }
    }, [
        loaded,
        options.showAxes,
        options.showGrid,
        options.showShaded,
        options.showWireframe,
        options.projection,
    ]);
    react_1.default.useEffect(function () {
        if (loaded) {
            var quality_1 = options.detail === "HIGH" ? options.highDetail : options.lowDetail;
            addTask(function () { return view.current && core.setRenderQuality.apply(core, __spreadArray([view.current], quality_1, false)); });
        }
    }, __spreadArray(__spreadArray([loaded, options.detail], options.highDetail, true), options.lowDetail, true));
    return view;
}
exports.default = useReactCADView;
