export declare type Projection = "ORTHOGRAPHIC" | "PERSPECTIVE";
export declare type Detail = "HIGH" | "LOW";
export declare type DetailSettings = [number, number];
export interface ViewOptions {
    showAxes: boolean;
    showGrid: boolean;
    showWireframe: boolean;
    showShaded: boolean;
    projection: Projection;
    detail: Detail;
    highDetail: DetailSettings;
    lowDetail: DetailSettings;
}
export declare type Viewpoint = "TOP" | "BOTTOM" | "LEFT" | "RIGHT" | "FRONT" | "BACK";
export interface ExportFns {
    exportSTL: () => Promise<void>;
    exportBREP: () => Promise<void>;
    exportSTEP: () => Promise<void>;
}
