"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DropdownLink = exports.Dropdown = exports.Section = exports.Separator = exports.Button = exports.Label = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var Label = function (_a) {
    var children = _a.children;
    return ((0, jsx_runtime_1.jsx)("span", __assign({ style: { padding: "8px 4px", fontSize: 14 } }, { children: children })));
};
exports.Label = Label;
var Button = function (_a) {
    var title = _a.title, onClick = _a.onClick, active = _a.active, children = _a.children;
    return ((0, jsx_runtime_1.jsx)("button", __assign({ type: "button", onClick: onClick, title: title, css: __assign({ alignItems: "center", border: "none", borderRadius: 4, cursor: "pointer", display: "inline-flex", fontSize: 18, fontWeight: "bold", height: 34, justifyContent: "center", margin: 2, padding: "8px 7px", writingMode: "horizontal-tb", "&:hover, &:focus-visible": {
                backgroundColor: "rgba(30,167,253,0.12)",
                color: "#1EA7FD",
            }, "&:focus-visible": {
                outline: "auto", // Ensures links have the same focus style
            }, "&:focus:not(:focus-visible)": {
                outline: "none",
            } }, (active
            ? {
                backgroundColor: "rgba(30,167,253,0.07)",
                color: "#1EA7FD",
            }
            : { backgroundColor: "transparent", color: "inherit" })) }, { children: children })));
};
exports.Button = Button;
var Separator = function () { return ((0, jsx_runtime_1.jsx)("div", { css: {
        height: 1,
        width: 20,
        backgroundColor: "rgba(0, 0, 0, 0.1)",
        margin: 6,
    } })); };
exports.Separator = Separator;
var Section = function (_a) {
    var children = _a.children;
    return ((0, jsx_runtime_1.jsx)("div", __assign({ style: { display: "flex", padding: "0 1px" } }, { children: children })));
};
exports.Section = Section;
var Dropdown = function (_a) {
    var open = _a.open, children = _a.children;
    return ((0, jsx_runtime_1.jsxs)("div", __assign({ style: {
            zIndex: Number.MAX_SAFE_INTEGER,
            position: "absolute",
            top: "-28px",
            left: "110%",
            display: open ? "inline-block" : "none",
            background: "rgba(255, 255, 255, 0.95)",
            filter: "drop-shadow(rgba(0, 0, 0, 0.05) 0px 5px 5px) drop-shadow(rgba(0, 0, 0, 0.1) 0px 1px 3px)",
            borderRadius: 8,
            fontSize: 12,
            writingMode: "horizontal-tb",
        } }, { children: [(0, jsx_runtime_1.jsx)("div", { style: {
                    position: "absolute",
                    top: "calc(50% - 8px)",
                    borderStyle: "solid",
                    left: -16,
                    borderWidth: "8px",
                    borderColor: "transparent rgba(255, 255, 255, 0.95) transparent transparent",
                } }), (0, jsx_runtime_1.jsx)("div", __assign({ style: {
                    minWidth: 180,
                    overflow: "hidden auto",
                    maxHeight: 432,
                    borderRadius: 8,
                } }, { children: children }))] })));
};
exports.Dropdown = Dropdown;
var DropdownLink = function (_a) {
    var onClick = _a.onClick, children = _a.children;
    return ((0, jsx_runtime_1.jsx)("a", __assign({ style: {
            fontSize: 12,
            transition: "all 150ms ease-out 0s",
            color: "rgba(51, 51, 51, 0.5)",
            textDecoration: "none",
            cursor: "pointer",
            justifyContent: "space-between",
            lineHeight: "18px",
            padding: "7px 15px",
            display: "flex",
            alignItems: "center",
        }, onClick: onClick }, { children: (0, jsx_runtime_1.jsx)("span", __assign({ style: {
                flex: "1 1 0%",
                textAlign: "left",
                color: "rgb(51, 51, 51)",
                fontWeight: 400,
            } }, { children: children })) })));
};
exports.DropdownLink = DropdownLink;
